Bug 46161 - [OOP] Invalid: Passing non-polymorphic to allocatable polymorphic dummy
[OOP] Invalid: Passing non-polymorphic to allocatable polymorphic dummy
Status: RESOLVED FIXED
Product: gcc
Classification: Unclassified
Component: fortran
4.6.0
: P3 normal
: ---
Assigned To: janus
: accepts-invalid
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2010-10-24 22:28 UTC by Tobias Burnus
Modified: 2010-10-27 21:42 UTC (History)
1 user (show)

See Also:
Host:
Target:
Build:
Known to work:
Known to fail:
Last reconfirmed: 2010-10-26 13:04:05


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Tobias Burnus 2010-10-24 22:28:07 UTC
Follow up to PR 45451 comment 14. The following is not detected:

Passing a non-polymorphic actual argument ("type(foo), allocatable") to an allocatable polymorphic dummy ("class(foo), allocatable").

From Fortran 2008: "12.5.2.5 Allocatable and pointer dummy variables"
"The actual argument shall be polymorphic if and only if the associated dummy argument is polymorphic, and either both the actual and dummy arguments shall be unlimited polymorphic, or the declared type of the actual argument shall be the same as the declared type of the dummy argument."

Test case: attachment 21613 [details] of PR 45451. Crayftn rejects the example with the following error message - gfortran prints no error:

  call doit(atx,acsr)
                ^     
ftn-1872 crayftn: ERROR BUG23, File = long2.f90, Line = 304, Column = 17 
  Dummy argument "ACSR" is a polymorphic ALLOCATABLE.  It requires a polymorphic ALLOCATABLE actual argument.
Comment 1 janus 2010-10-26 13:04:05 UTC
Preliminary patch:


Index: gcc/fortran/interface.c
===================================================================
--- gcc/fortran/interface.c     (revision 165936)
+++ gcc/fortran/interface.c     (working copy)
@@ -1519,6 +1520,18 @@ compare_parameter (gfc_symbol *formal, gfc_expr *a
                   gfc_typename (&formal->ts));
       return 0;
     }
+    
+  /* F2003, 12.5.2.5.  */
+  if (formal->ts.type == BT_CLASS
+      && (CLASS_DATA (formal)->attr.pointer
+          || CLASS_DATA (formal)->attr.allocatable)
+      && actual->ts.type != BT_CLASS)
+    {
+      if (where)
+       gfc_error ("Actual argument to '%s' at %L must be polymorphic",
+                   formal->name, &actual->where);
+      return 0;
+    }
 
   if (formal->attr.codimension)
     {
Comment 2 janus 2010-10-27 21:41:56 UTC
Author: janus
Date: Wed Oct 27 21:41:52 2010
New Revision: 166018

URL: http://gcc.gnu.org/viewcvs?root=gcc&view=rev&rev=166018
Log:
2010-10-27  Janus Weil  <janus@gcc.gnu.org>

	PR fortran/46161
	* interface.c (compare_allocatable): Handle polymorphic allocatables.
	(compare_parameter): Add two error messages for polymorphic dummies.

2010-10-27  Janus Weil  <janus@gcc.gnu.org>

	PR fortran/46161
	* gfortran.dg/class_dummy_3.f03: New.

Added:
    trunk/gcc/testsuite/gfortran.dg/class_dummy_3.f03
Modified:
    trunk/gcc/fortran/ChangeLog
    trunk/gcc/fortran/interface.c
    trunk/gcc/testsuite/ChangeLog
Comment 3 janus 2010-10-27 21:42:43 UTC
Fixed with r166018. Closing.